<?php
// Copyright (c) 2002-2003, Index Data.
// $Id: config.php,v 1.41 2003/06/10 12:38:10 adam Exp $

// General global settings for Toolkit Lite

// Indent used when producing XML
$indent = "  ";

// Indent when producing HTML
$HTMLindent = "&nbsp;&nbsp;&nbsp;&nbsp;";

// Admin interface Language
$admin_lang = "da";

// Members of an admin-session:
$context = array("action", "cwd");

// XML header used in all XML
$xml_header = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n";

// XML schema instance attribute
$xml_schema_instance_attr = "xsi:noNamespaceSchemaLocation";

// XML schema instance namespace
$xml_schema_instance_ns = "http://www.w3.org/2001/XMLSchema-instance";

//XSD header used in all XSD
$xsd_header = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>
<xs:schema xmlns:xs=\"http://www.w3.org/2001/XMLSchema\">";

//XSD footer used in all XSD
$xsd_footer = "</xs:schema>";

//XSD attributes used in all XSD
$xsd_attributes = "<xs:attribute name=\"creator\" type=\"xs:string\">
  <xs:annotation>
    <xs:appinfo>
      <fieldtype>hidden</fieldtype>
    </xs:appinfo>
  </xs:annotation>
</xs:attribute>
<xs:attribute name=\"created\" type=\"xs:string\">
  <xs:annotation>
    <xs:appinfo>
      <fieldtype>hidden</fieldtype>
    </xs:appinfo>
  </xs:annotation>
</xs:attribute>
<xs:attribute name=\"modifier\" type=\"xs:string\">
  <xs:annotation>
    <xs:appinfo>
      <fieldtype>hidden</fieldtype>
    </xs:appinfo>
  </xs:annotation>
</xs:attribute>
<xs:attribute name=\"modified\" type=\"xs:string\">
  <xs:annotation>
    <xs:appinfo>
      <fieldtype>hidden</fieldtype>
    </xs:appinfo>
  </xs:annotation>
</xs:attribute>";

// The path to the XML schema repository
$xsd_path = "schemas";

// The name of the XML editor php script
$xml_editor = "xform2.php";

// The property script
$admin_property = "prop.php";

// The name of the XML schema editor
$xsd_editor = "schema-editor.php";

// List of URL's in a portal
$url_list_file = "urls.tkl";

// The record suffix
$xml_suffix = ".tkl";

// The directory configuration file
$dir_config = "directory.tkl";

// The directory schema
$dir_schema = "directory.xsd";

// The administrator interface
$admin_script = "admin.php";

// The administrator system call script
$admin_process = "process.php";

// The browser script
$browse_script = "dirbrowse.php";

// Global portal index file
$global_index = "global.index";

// Portal specific user list
$user_list = "users.tkl";

// Portal specific list of bad urls
$bad_urls = "badurls.tkl";

// XSLT stylesheet to render the bad urls list
$bad_urls_xslt = "badurls.xsl";

// User privileges
$privileges = array(
			'administrator'	=>	array(
							'allow'	=> array(
										'write'	=> '@portal',
										'read'	=> '@portal',
										'create'=> '@portal',
										'index' => 1,
								   ),
							'deny'	=> array(),
						),

			'user'		=>	array(
							'allow'	=> array(
										'write'	=> '@home',
										'read'	=> '@portal',
										'create'=> '@home',
								   ),
							'deny'	=> array(
										'write'	=> array('directory.tkl'=>1, 'users.tkl'=>1, '*.xsd'=>1),
										'read'	=> array('users.tkl'=>1, '*.xsd'=>1),
								   ),
						),
			'spectator'	=>	array(
							'allow'	=> array(
										'read' => '@portal'
								   ),
							'deny'	=> array(
										'read'	=> array('users.tkl'=>1),
								   ),
						),
	      );

// Document root directory
//$doc_root = "tkl";

// The languages supported by the portal
$languages = array(
			0	=>	array("abbr"=>"da", "desc"=>"Dansk"),
			1	=>	array("abbr"=>"en", "desc"=>"Engelsk") );

//Mandatory fields
//Syntax: fieldname, required field [checked], searchable [checked], language dependant [checked], repeadable [checked], XML fieldname, field type [text, textarea, dropdown] , helptext.
$mandatory_fields = array(
    array('Titel', 'checked', 'checked', 'checked', '', 'title', 'text', 'Her skal titlen st'),
    array('Type', 'checked', 'checked', '', '', 'type', 'text', 'Postens type'),
    array('Beskrivelse', 'checked', 'checked', 'checked', '', 'description', 'text', 'Kort beskrivelse af posten'),
    array('URL', 'checked', 'checked', '', '', 'identifier', 'url', 'Resourcens URL'),
    array('Emneord', 'checked', 'checked', 'checked', 'checked', 'subject', 'text', 'Emneord der kan knyttes til resourcen'),
    array('Forfatter', 'checked', 'checked', '', 'checked', 'creator', 'text', 'Forfatterens navn'),
    array('Udgiver', 'checked', 'checked', '', 'checked', 'publisher', 'text', 'Den organisation der udgiver resourcen'),
);

//Number of terms to show in scan.
$scannumber = 10;

//The timeout for the robot when it connects and reads/writes (in seconds)
$robotTimeout = 10;

//The number of times in a row  a URL should have errors before a email is send to the owner of the document.
$robotErrorNr = 3;

//Email address for the administrator of the URL checker.
$robot_admin_email = "perhans@indexdata.dk";

// Entity references
$ent_ref = array(
			'amp'	=>	'&',
			'lt'  =>	'<',
			'gt'  =>	'>',
		);

// The name of the portal
$portalName = "Def Link";

$trans_lang = array(
    '1' => array('da' => 'Navnet p denne dokumenttype', 'en' => 'The name of this document type'),
    '2' => array('da' => 'Feltnavn', 'en' => 'Field name'),
    '3' => array('da' => 'XML feltnavn', 'en' => 'XML field name'),
    '4' => array('da' => 'Attributtype', 'en' => 'Attribute type'),
    '5' => array('da' => 'Sti til autoritetsfil', 'en' => 'Path to authorisation files'),
    '6' => array('da' => 'Hjlpetekst', 'en' => 'Help text'),
    '7' => array('da' => 'Obligatorisk', 'en' => 'Mandatory'),
    '8' => array('da' => 'Sgbar', 'en' => 'Searchable'),
    '9' => array('da' => 'Sprogafhngig', 'en' => 'Language dependant'),
    '10' => array('da' => 'Kan gentages', 'en' => 'Repeadable'),
    '11' => array('da' => 'Op', 'en' => 'Up'),
    '12' => array('da' => 'Ned', 'en' => 'Down'),
    '13' => array('da' => 'Slet', 'en' => 'Delete'),
    '14' => array('da' => 'Underfelt', 'en' => 'Sub field'),
    '15' => array('da' => 'Attribut', 'en' => 'Attribute'),
    '16' => array('da' => 'Attributnavn', 'en' => 'Attribut name'),
    '17' => array('da' => 'XML attributnavn', 'en' => 'XML attribut name'),
    '18' => array('da' => 'Gem', 'en' => 'Save'),
    '19' => array('da' => 'Nyt felt', 'en' => 'New field'),
    '20' => array('da' => 'Ny attribut', 'en' => 'New attribute'),
    '21' => array('da' => 'Tilbage', 'en' => 'Back'),
    '22' => array('da' => 'Felttype', 'en' => 'Field type'),
    '23' => array('da' => 'Vlg type', 'en' => 'Chose type'),
    '24' => array('da' => 'Choice', 'en' => 'Choice'),
    '25' => array('da' => 'Ny choice', 'en' => 'New choice')
);

// $Log: config.php,v $
// Revision 1.41  2003/06/10 12:38:10  adam
// Dollar id in headers
//
// Revision 1.40  2003/05/06 12:38:30  perhans
// Added language support in teh schema editor and fixed some bugs.
// Added a file upload field type.
// Implemented teh new design
//
// Revision 1.39  2003/03/03 14:20:47  sondberg
// The xform2 is now the default one.
//
// Revision 1.38  2003/01/08 14:29:58  perhans
// Added creator, createed, modifier, modified attributes
//
// Revision 1.37  2002/10/31 15:50:20  sondberg
// Reintroduced $admin_property.
//
// Revision 1.36  2002/10/25 13:47:31  sondberg
// Added bad_urls and bad_urls_xslt.
//
// Revision 1.35  2002/10/23 13:36:41  quinn
// More changes to mail notification
//
// Revision 1.34  2002/10/23 12:39:31  perhans
// Made some changes that had to do with sending of emilas in case a URL is dead.
//
// Revision 1.33  2002/08/15 10:01:06  sondberg
// Added a list of entity references handled separately by php after sablotron.
//
// Revision 1.32  2002/07/26 12:56:22  sondberg
// Added symbol dc_dot_xsd.
//
// Revision 1.31  2002/07/25 12:38:31  perhans
// Added a robotTimeout to controle the robots timeout.
//
// Revision 1.30  2002/07/25 08:13:02  sondberg
// Added symbol $admin_prop.
//
// Revision 1.29  2002/07/24 07:49:22  sondberg
// Added suffix_regexp.
//
// Revision 1.28  2002/07/22 15:02:42  sondberg
// Urls list file name changed to have suffix .tkl.
//
// Revision 1.27  2002/07/18 09:23:31  perhans
// Major update of schema-editor.php to handle sub elements and attributes.
//
// Revision 1.26  2002/07/12 09:54:04  sondberg
// Added symbol $url_list_file.
//
// Revision 1.25  2002/07/11 13:16:46  sondberg
// Added symbol $admin_lang.
//
// Revision 1.24  2002/07/05 16:21:26  sondberg
// More strict version of $privileges.
//
// Revision 1.23  2002/07/05 14:11:12  sondberg
// Added $privileges.
//
// Revision 1.22  2002/07/04 16:50:17  sondberg
// Added symbol $user_list.
//
// Revision 1.21  2002/07/03 10:27:11  sondberg
// Added symbol $xsd_editor.
//
// Revision 1.20  2002/07/02 16:28:02  sondberg
// Changed browse.php to dirbrowse.php.
//
// Revision 1.19  2002/07/02 16:12:05  sondberg
// Added symbol $browse_script.
//
// Revision 1.18  2002/07/02 15:55:42  perhans
// Small change
//
// Revision 1.17  2002/07/02 15:35:25  perhans
// Added a browse pop up window (browse.php) to xform.xsl
//
// Revision 1.16  2002/07/01 08:40:03  sondberg
// The symbol $context is now placed in this file.
//
// Revision 1.15  2002/06/28 12:58:12  perhans
// Added a "repeadable" checkbox
//
// Revision 1.14  2002/06/28 11:12:40  sondberg
// Added $dir_schema.
//
// Revision 1.13  2002/06/27 17:02:43  sondberg
// Toolkit lite suffix is now .tkl
//
// Revision 1.12  2002/06/27 15:02:58  sondberg
// Language abbreviations changed.
//
// Revision 1.11  2002/06/27 08:22:56  perhans
// Removed then "DC:" prefix in the madatory fields in config.php and added support for
// annotation subtree in the root field, userspcified filename and fixed bug in the
// way type is declared.
//
// Revision 1.10  2002/06/25 14:12:45  sondberg
// New structure of $languages. NB: count($languages) is still the number of supported languages.
//
// Revision 1.9  2002/06/24 15:32:04  sondberg
// Paths relative to apache document root.
//
// Revision 1.8  2002/06/24 09:55:54  sondberg
// Added symbol $xml_suffix.
//
// Revision 1.7  2002/06/21 09:59:52  sondberg
// Added a few XML schema instance specific symbols.
//
// Revision 1.6  2002/06/20 10:57:52  sondberg
// Changed doc root to be compatible with "the Wonder Portal".
//
// Revision 1.5  2002/06/20 08:04:05  perhans
// Added default fields to config.php and added support for default fields in the schema editor
// plus other minor changes.
//
// Revision 1.4  2002/06/19 10:36:28  sondberg
// Added directory navigation functionality.
//
// Revision 1.3  2002/06/19 08:18:55  sondberg
// Added $admin_script.
//
// Revision 1.2  2002/06/13 13:01:00  perhans
// Added the schema editor and added some values in config.php.
//
// Revision 1.1  2002/06/06 13:18:36  sondberg
// Added this file to repository.
//

?>
