<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="1.0">

    <xsl:output method="xml" indent="yes" encoding="ISO-8859-1"/>


<xsl:template match="/record">
   <link>
       <xsl:apply-templates select="DC.Date.X-MetadataLastModified"/>
       <xsl:apply-templates select="DC.Title"/>
       <xsl:apply-templates select="DC.Identifier"/>
       <xsl:apply-templates select="DC.Description"/>
       <xsl:apply-templates select="DC.Format"/>
       <xsl:apply-templates select="DC.Language"/>
       <xsl:apply-templates select="DC.Type"/>
       <xsl:apply-templates select="DEF.Library"/>
       <xsl:apply-templates select="DEF.Status"/>
       <xsl:apply-templates select="DEF.HarvestOption"/>
   </link>
</xsl:template>

<xsl:template match="DC.Date.X-MetadataLastModified">
    <xsl:attribute name="created"><xsl:value-of select="."/></xsl:attribute>
</xsl:template>

<xsl:template match="DEF.Library">
    <library><xsl:value-of select="."/></library>
</xsl:template>

<xsl:template match="DEF.Status">
    <def-status><xsl:value-of select="."/></def-status>
</xsl:template>

<xsl:template match="DC.Format">
    <format><xsl:value-of select="."/></format>
</xsl:template>

<xsl:template match="DC.Title">
    <title xml:lang="da"><xsl:value-of select="."/></title>
    <title xml:lang="en"><xsl:value-of select="."/></title>
</xsl:template>

<xsl:template match="DC.Description">
    <description><xsl:call-template name="text"/></description>
</xsl:template>

<xsl:template match="DC.Identifier[@scheme='URL']">
    <identifier><xsl:value-of select="."/></identifier>
</xsl:template>

<xsl:template match="DC.Type[@scheme='DEFType']">
    <type>
      <xsl:choose>
        <xsl:when test=". = 'DEFB'">DEFO</xsl:when>
	<xsl:otherwise><xsl:value-of select="."/></xsl:otherwise>
      </xsl:choose>
    </type>
</xsl:template>

<xsl:template match="DEF.HarvestOption">
  <harvest>
    <xsl:attribute name="strategy">star</xsl:attribute>
    <xsl:attribute name="steps">3</xsl:attribute>
    <xsl:if test=". = 'Nej'">no</xsl:if>
    <xsl:if test=". = 'Ja'">
      <xsl:text>yes</xsl:text>
    </xsl:if>
  </harvest>
</xsl:template>

<xsl:template match="DC.Language">
  <language>
    <xsl:choose>
      <xsl:when test=". = 'dan'">da</xsl:when>
      <xsl:when test=". = 'eng'">en</xsl:when>
      <xsl:when test=". = 'swe'">sv</xsl:when>
      <xsl:when test=". = 'nno'">no</xsl:when>
      <xsl:otherwise><xsl:value-of select="."/></xsl:otherwise>
    </xsl:choose>
  </language>
</xsl:template>

<xsl:template match="node()"/>

<xsl:template name="text">
    <xsl:attribute name="xml:lang">
	<xsl:if test="@lang='dan'">da</xsl:if>
	<xsl:if test="@lang='eng'">en</xsl:if>
    </xsl:attribute>
    <xsl:value-of select="."/>
</xsl:template>

</xsl:stylesheet>

