<?php
// Copyright (c) 2002-2003, Index Data.
// $Id: robot_batch.php,v 1.7 2003/06/10 12:38:11 adam Exp $

$cwd = $argv[1];
/*Turns debugging mode on.*/
$debug = $argv[2];
require("config.php");
require("standards.php");
require("util/checkurl.php");
if (is_file("$cwd/local_config.phpi")) {
    require("$cwd/local_config.phpi");
} else {
   echo "The file $cwd/local_config.phpi was not found. You will have to create this file in order to be able to run the robot from the command line. The file should contain the variable admin_URL which is the URL to the tklite directory, without http:// in front of it\n";
}

echo "CWD='$cwd'\n";

if (!$url) {
   $url = "";
   $singleURL = 0;
}



/*The filename of the file containing the URLs that have been tested bad. */
//$badfilename = $_SERVER['DOCUMENT_ROOT']."/$cwd/badurls.tkl";
$badfilename = "$cwd/badurls.tkl";
echo "BADFILE='$badfilename'\n";
$badarray = basename (strval($badfilename),".tkl");
$badnr = 0;
$myarray = array();

/*The filename of the file containing the URLs to be tested. */
//$checkfilename = $_SERVER['DOCUMENT_ROOT']."/$cwd/urls.tkl";
$checkfilename = "$cwd/urls.tkl";
$checkarray = basename (strval($checkfilename),".tkl");

function startElement($parser, $name, $attribs) {
    global $debug, $currentArrayName, $tagName, $i;
    $tagName = $name;
    if ($debug) {
        print "$name";
    }
    if (sizeof($attribs)) {
        while (list($k, $v) = each($attribs)) {
            if ($debug) {
                print " $k=\"$v\"";
            }
            $GLOBALS[$currentArrayName][$name][$k] = $v;
        }
    }
    if ($debug) {
        print "&gt;";
    }
    if ($name == "BADURL" || $name == "CHECKURL") {
        $i++;
    }
}

function endElement($parser, $name) {
    global $debug;
    if ($debug) {
        print "&lt;/$name&gt;";
    }
}

function characterData($parser, $data) {
    global $debug, $currentArrayName, $tagName, $i, $oldi, $olddata, $myarray;
    if (!$oldi) {
        $oldi = $i;
    }
    if ($debug) {
        print "$data";
    }
    if (trim($data) != "") {
        $GLOBALS[$currentArrayName][$i][$tagName] .= $data;
    }
}

function defaultHandler($parser, $data) {
    global $debug;
    if (substr($data, 0, 1) == "&" && substr($data, -1, 1) == ";") {
        if ($debug) {
            printf('%s',
                htmlspecialchars($data));
        }
    } else {
        if ($debug) {
            printf('%s',
                htmlspecialchars($data));
        }
    }
}

function new_xml_parser($filename) {
    global $parser_file;

    $xml_parser = xml_parser_create();
    xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, 1);
    xml_set_element_handler($xml_parser, "startElement", "endElement");
    xml_set_character_data_handler($xml_parser, "characterData");
    xml_set_processing_instruction_handler($xml_parser, "PIHandler");
    xml_set_default_handler($xml_parser, "defaultHandler");

    if (!($fp = @fopen($filename, "r"))) {
        return false;
    }
    if (!is_array($parser_file)) {
        settype($parser_file, "array");
    }
    $parser_file[$xml_parser] = $filename;
    return array($xml_parser, $fp);
}

function readXML($filename) {
    global $debug, $currentArrayName, $i;
    $i = -1;
    $currentArrayName = basename (strval($filename),".tkl");
    global $$currentArrayName;
    if (!(list($xml_parser, $fp) = new_xml_parser($filename))) {
        die("Kunne ikke åbne XML fil $filename\n");
    }
    while ($data = fread($fp, 4096)) {
        if (!xml_parse($xml_parser, $data, feof($fp))) {
            die(sprintf("XML error: %s at line %d\n",
                        xml_error_string(xml_get_error_code($xml_parser)),
                        xml_get_current_line_number($xml_parser)));
        }
    }
    if ($debug) {
        print "Parse complete\n";
        echo "$currentArrayName: \n";
        print_r($$currentArrayName);
        echo "\n";
    }
    if (!is_array($$currentArrayName)) {
        $$currentArrayName = array();
    }
}

//function escape_amp ($str) {
//    $str = preg_replace("/&amp;/", "&", $str);
//    $str = preg_replace("/&/", "&amp;", $str);
//
//    return $str;
//}


function writeXML() {
    global $badfilename, $badarrayNew, $robotErrorNr;
    reset($badarrayNew);
    $fileid = fopen($badfilename, "w+");
    fputs ($fileid, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    fputs ($fileid, "<badurls>\n");
    foreach ($badarrayNew as $bad) {
        if ($bad != "") {
            fputs ($fileid, "  <BADURL>\n");
	    fputs ($fileid, "    <USER>".$bad['USER']."</USER>\n");
            fputs ($fileid, "    <URL>".escape_amp($bad['URL'])."</URL>\n");
            fputs ($fileid, "    <FILENAME>".$bad['FILENAME']."</FILENAME>\n");
            fputs ($fileid, "    <ERRORCODE>".escape_amp($bad['ERRORCODE'])."</ERRORCODE>\n");
            fputs ($fileid, "    <CHECKEDNUMBER>".$bad['CHECKEDNUMBER']."</CHECKEDNUMBER>\n");
            fputs ($fileid, "    <CHECKEDLAST>".$bad['CHECKEDLAST']."</CHECKEDLAST>\n");
            fputs ($fileid, "  </BADURL>\n");
            if ($bad['CHECKEDNUMBER'] >= $robotErrorNr) {
                sendEmail($bad);
            }
        }
    }
    fputs ($fileid, "</badurls>\n");
    fclose($fileid);
}

function sendEmail($bad) {
    global $checkfilename, $portalName, $cwd, $_SERVER, $urlchecker_admin, $robot_admin_email, $admin_URL;
$debug=1;
    if ($bad['USER']) {
//        $user_info = get_user_info($bad['USER'], "def3", "/var/www");
	$user_info = get_user_info($bad['USER'], $cwd);
        if (!is_array($user_info)) {
            if ($debug) {
                echo "Ingen brugeroplysninger for ".$bad['USER']."\n";
            }
            return "";
        } elseif (!$user_info["email"]) {
            if ($debug) {
                echo "Ingen email adresse for ".$bad['USER']."\n";
            }
            return "";
        }
        $path = dirname($_SERVER['SCRIPT_NAME']);
	if ($path == "") {
	    $path = $admin_URL;
	}
        $tekst = "Denne mail er automatisk genereret af ".$portalName."s URL check system.\n
Din post \"".get_title($bad['FILENAME'])."\" er nu blevet checket ".$bad['CHECKEDNUMBER']." gange, sidste gang ".$bad['CHECKEDLAST'].", og har
hver gang returneret fejlen: ".$bad['ERRORCODE'].".\n
Du kan se siden her: ".$bad['URL']."\n
Posten kan rettes her: http://".$_SERVER['HTTP_HOST'].$path."/xform.php?cwd=$cwd&xml_file=".$bad['FILENAME'];
        mail($user_info["email"], "En af dine poster trnger til opdatering", $tekst, "From: $robot_admin_email");
        if ($debug) {
            echo "Mail sendt to ".$user_info["name"]." (".$user_info["email"].")\n";
        }
    } else {
        if ($debug) {
            echo "Intet brugernavn i $checkfilename\n";
        }
    }
}

function makeSingleURLStuff($url) {
    global $checkarray, $badarray, $singleURL;
    $GLOBALS[$checkarray][0]['URL'] = $url;
    $GLOBALS[$badarray][0]['URL'] = "";
    $singleURL = 1;
}


if ($url == "" && is_file($badfilename)) {
    readXML($badfilename);
} else {
    $arrayname = basename (strval($badfilename),".tkl");
    $$arrayname = array();
}

if ($url != "") {
    makeSingleURLStuff($url);
} elseif ($checkfilename) {
    readXML($checkfilename);
}


reset($$checkarray);

//$URLarray = parse_url("http://www.hw.ac.uk/libWWW/irn/pinakes/pinakes.html");
/*This is the main URL check loop. */

foreach ($$checkarray as $page) {
    reset($$badarray);
    $outarray = "";
    $URLarray = parse_url($page['URL']);
    if (!array_key_exists("port", $URLarray)) {
        $URLarray['port'] = "80";
    }
    if (!array_key_exists("path", $URLarray) || trim($URLarray['path']) == "") {
        $URLarray['path'] = "/";
    }
    if (!array_key_exists("query", $URLarray)) {
        $URLarray['query'] = "";
    } else {
        $URLarray['query'] = "?".$URLarray['query'];
    }
    /* Get the port for the WWW service. */
    $service_port = getservbyname ('www', 'tcp');

    /* Get the IP address for the target host. */
    $address = gethostbyname ($URLarray['host']);
    print "URL: ".$page['URL']."\n";
    print "USER: ".$page['USER']."\n\n";
    $flags = array('debug' => $debug,
                    'retries' => 5,
                    'timeout' => 10,);
    $res = check_url($page['URL'],$flags);
    if ($debug) {
        print_r($res);
    }
    $j = -1;
    $badkey = -1;
    foreach ($$badarray as $badpage) {
        $j++;
        if ($badpage != "") {
            if (array_search($page['URL'],$badpage)) {
                $badkey = $j;
            }
        }
    }
    if ($res['HTTP-code'] == 200 && $res['HTTP-code-redirect'] != "301") {
        flush();
        if ($singleURL) {
            echo "URLen er OK.\n";
        }
        if ($badkey != -1) {
           $GLOBALS[$badarray][$badkey] = "";
        }
    } else {
        if ($res['HTTP-code'] == "") {
            print "Errorcode: ".$res['error']."\n";
        } elseif ($res['HTTP-code-redirect'] == "301") {
            print "Errorcode: ".$res['HTTP-code-redirect']."\n";
        } else {
            print "Errorcode: ".$res['HTTP-code']."\n";
        }
        flush();
        if ($singleURL) {
            echo "URLen er IKKE OK. Fejlmeddelelse:". $res['HTTP-message'];
        } else {
            if ($badkey != -1) {
                $badarrayNew[$badnr]['CHECKEDNUMBER'] = $GLOBALS[$badarray][$badkey]['CHECKEDNUMBER'] + 1;
            } else {
                $badarrayNew[$badnr]['CHECKEDNUMBER'] = 1;
            }
            $badarrayNew[$badnr]['URL'] = $page['URL'];
            $badarrayNew[$badnr]['FILENAME'] = $page['FILENAME'];
            if ($res['HTTP-code'] == "") {
                $badarrayNew[$badnr]['ERRORCODE'] = $res['error'];
            } else {
                if ($res['HTTP-code-redirect'] == "301" ) {
                    $badarrayNew[$badnr]['ERRORCODE'] = $res['HTTP-code-redirect'];
                    $badarrayNew[$badnr]['PERMANENTURL'] = $res['permanent-url'];
                } else {
                    $badarrayNew[$badnr]['ERRORCODE'] = $res['HTTP-code'];
                }
            }
            $badarrayNew[$badnr]['CHECKEDLAST'] = date("Y-m-d",time());
            $badarrayNew[$badnr]['USER'] = $page['USER'];
            $badnr++;
        }
    }

}

if ($debug) {
        print "</pre>";
        echo "\n$badarray: \n";
        print_r($$badarray);
        echo "\n";
    }

if (!$singleURL) {
    echo "Writing XML\n";
    if ($debug) {
        print_r($badarrayNew);
    }
    writeXML();
}

?>
