<?php

// Copyright (c) 2002-2003, Index Data.
// $Id: xform2.php,v 1.17 2003/06/24 08:47:26 sondberg Exp $

require "config.php";
require "standards.php";
require "domtools.php";
require "search.php";
require "xform_valid.php";

if (!$cwd && $xml_file) { // Infer cwd from file path
    $cwd = extract_cwd($xml_file);
}
session_start();

find_portal_root();
require "read_local_config.php";
$this_user = check_auth_user();
$style_indent = 0;
$max_indent = 0;
//$debug = 1;
if (strlen($url)) {
    $xml_raw = get_metadata($url);
}

if (strlen($choose_dir)) {			// If $choose_dir is set, change cwd to the new place...
    $cwd = "$doc_root/$choose_dir";
    find_portal_root();
    $this_user = check_auth_user();
    $choose_dir = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$choose_dir";
}

if (is_granted($cwd, "write") && ( ($xml_file && is_granted($xml_file, "write")) ||
    				   ($write_file && is_granted($write_file, "write")) ||
				   ($write && $choose_dir && is_granted("$choose_dir$write", "write")) ) ) {
    $allow_write = 1;
    if (strlen($choose_dir) && !strlen($write_file)) {
	$write_file = $choose_dir;
    }
} elseif ($url) {
    $allow_write = 1;
    $file_spec = 1;		// So far, we always allow user to specify file name
} else {
    echo "<b>Skriveadgang ngtet</b><br>";
    $save = 0;			// Never save anything, if we're not allowed to...
}

if ($xml_file) {
    if (!is_granted($xml_file, "read")) {
	exception("You're not allowed to open this file: '$xml_file'");
	die;
    }
}

$typemap = array(	// These objects constitutes our basic building blocks, somehow...
			'xs:string'     	=>      'text',
			'xs:date'       	=>      'text',
			'xs:integer'    	=>      'text',
			'xs:decimal'		=>	'text',
			'xs:positiveInteger'	=>	'text',
			'xs:boolean'		=>	'text',
			'xs:anyURI'		=>	'text',
			'xs:anyType'		=>	'text',
		);

if ($xml_file || $xml_raw) {	// If we have an xml-file we want to load and parse it...
    if ($xml_raw) {
	if (!($dom_xml = domxml_open_mem($xml_raw))) {
	    echo "Can't open/parse raw xml<br><pre>", htmlentities($xml_raw), "</pre>\n";
	    die;
	}
    } else {
	$raw_tkl = open_tkl_file($xml_file);
	if (!($dom_xml = domxml_open_mem($raw_tkl))) {
	    echo "Can't parse xml file '$xml_file'";
	    die;
	}
    }
    $doc = $dom_xml->document_element();
    $doc_elem = $doc->tagname();
    $schemaname = "$doc_elem.xsd";
    if (file_exists($xsd_cand = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$xsd_path/$schemaname")) {
	$schema = $xsd_cand;
    } else {
	$schema = "$xsd_path/$schemaname";
    }

    if (!@file_exists($schema)) {
	echo "<b>Du kan ikke editere i denne post.</b>";
	die;
    }
    if (!($dom_schema = domxml_open_file($schema))) {
	echo "Unable to construct DOM object";
	die;
    }
    create_struct($f = array(), $dom_xml->document_element());
}


if (!strlen($write_file)) {
    $write_file = $xml_file;
}

if (is_array($f)) {		// Check structure of $f, add info about schema and render xml...
    if (count($f) > 1) {
	exception("No more than one root tag");
    }
    if (list($field, $content) = each($f)) {
	if (count($content) > 1) {
	    exception("Root tag must only occur once");
	}
	if ($debug) {
	    echo "Root tag is '$field'<br>";
	}
	if (!$start) {		// If we have no start tag given, use the root tag as start tag
	    $start = $field;
	}
	if (list($offset, $value) = each($content)) {
	    if (!strlen($creator = $value['attr']['creator']['value'])) {
		$creator = $f[$field][$offset]['attr']['creator']['value'] = $this_user['login'];
	    }
	    if (!strlen($created = $value['attr']['created']['value'])) {
		$f[$field][$offset]['attr']['created']['value'] = date("Y-m-d, H:i:s", time());
	    }
	    $f[$field][$offset]['attr']['modifier']['value'] = $this_user['login'];
	    $f[$field][$offset]['attr']['modified']['value'] = date("Y-m-d, H:i:s", time());
	}
	$schema_candidate = "$field.xsd";
    }
    if ($debug) {
	echo "<pre>", htmlentities($xml_data), "</pre>";
	echo "<hr>\n";
    }
} else {
    //$f = array();
}
if ($debug) {
    echo "<pre>";
    print_r($f);
    echo "</pre><hr>";
}
if (!$schema) {
    if (!$schema_candidate) {
	echo "No schema information available";
	die;
    } else {
	$schema = $schema_candidate;
	if (file_exists($xsd_cand = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$xsd_path/$schema")) {
	    $schema = $xsd_cand;
	} else {
	    $schema = "$xsd_path/$schema";
	}
    }
}
if (!strlen($creator)) {
    $creator = $this_user['login'];
}
if (!@file_exists($schema)) {
    echo "<b>Du kan ikke editere i denne post.</b>";
    die;
}
if (!($dom_schema = domxml_open_file($schema))) {
    echo "Unable to construct DOM object";
    die;
}
$schema_root = $dom_schema->root();
if (!is_array($f)) {			// We're dealing with an empty document...
    $default_file = $schema_root->get_attribute('default_file');
    if (strlen($default_file)) {
	$abs_def_file = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$default_file";
	if (!($dom_xml = domxml_open_file($abs_def_file))) {
	    echo "Can't open/parse default xml file '$abs_def_file'";
	    die;
	}
	create_struct($f = array(), $dom_xml->document_element());
    }
}

$schema_annotation = annotation($schema_root); // Parse optional schema annotations...


$root_elements = dom_select_ext($schema_root, array("element"));
$no_of_elm = count($root_elements);
if ($no_of_elm != 1) {
    die("Number of root elements must be 1, the number found is $no_of_elm");
} else {
    $schema_element_root = $root_elements[0];
}


function create_namespace ($node, &$ns) {
    // We adopt the Perl namespace model, where a specific identifier can co-exist in
    // various contexts simultaneously

    if ($tag = $node->tagname) {
	if ($name = $node->get_attribute('name')) {
	    $ns[$name][$tag] = $node;
	}
    }
    if ($kids = $node->child_nodes()) {
	foreach ($kids as $kid) {
	    create_namespace($kid, $ns);
	}
    }
}


function get_value (&$f, &$path, $type="") {
    $value = get_node($f, $path);
    if ($type == "xs:anyType") {
	if ($node = $value['parent']) {
	    return dump_xml($node);
	} else {
	    return escape_amp(stripslashes($value['value']));
	}
    } else {
	return escape_amp(stripslashes($value['value']));
    }
}


function get_node (&$f, &$path) {
    $value = $f;
    foreach ($path as $key) {
	$value = $value[$key];
    }
    return $value;
}


function swap_elements ($path1, $path2) {
    global $f;

    if (!is_array($path1)) {
	$path1 = make_array($path1);
    }
    if (!is_array($path2)) {
	$path2 = make_array($path2);
    }
    $node1 = get_node($f, $path1);
    $node2 = get_node($f, $path2);
    set_node($path1, $node2);
    set_node($path2, $node1);
}


function make_array ($path_str) {
    $path_str = preg_replace("/^\[/", "", $path_str);
    $path_str = preg_replace("/\]$/", "", $path_str);
    return preg_split("/\]\[/", $path_str);
}


function get_last(&$f, &$path, $field) {
    // Checks the sub-structure for non-empty nodes and returns the offset of last non-empty node

    $extended_path = array_merge($path, $field);
    $nodeset = get_node($f, $extended_path);

    if (is_array($nodeset)) {
	for ($count = count($nodeset); $count >= 0; $count--) {
	    $node = $nodeset[$count];
	    if (strlen(trim($node['value']))) {		// If the value is non-empty this qualify as last node
		return $count;
	    }
	    if (is_array($attributes = $node['attr'])) {	// Check for attributes
		foreach ($attributes as $key => $value) {
		    if (trim($key)) {
			return $count;
		    }
		}
	    }
	    if (is_array($subtree = $node['subtree'])) {	// Otherwise, check for non-empty sub-fields
		foreach ($subtree as $sub_field => $dummy) {
		    if (get_last($f, array_merge($extended_path, $count, 'subtree'), $sub_field) != -1) {
			return $count;
		    }
		}
	    }
	}
    }
    return -1;
}


function get_form_name (&$path) {
    // Generates a generic path name for the specific xml node

    return "f" . get_path_str($path) . "[value]";
}


function get_path_str (&$path) {
    // Generates a generic path string for the specific xml node

    return "[" . join("][", $path) . "]";
}

function make_attr ($attr) {
    $ret = "";
    if (is_array($attr)) {
	foreach ($attr as $key => $value) {
	    while (is_array($value)) {
		$value = stripslashes($value['value']);
	    }
	    $ret .= " $key=\"" . escape_amp($value) . "\"";
	}
    }
    return $ret;
}


function make_info (&$info, $level) {
    // Based on the $info structure this function returns an info tag to include in the meta xml-document

    global $indent;
    if (!is_array($info)) {
	return;
    }
    $ret = str_repeat($indent, $level) . "<info>\n";
    foreach ($info as $tag => $entry) {
	$ret .= str_repeat($indent, $level + 1) . "<$tag";
	if (is_array($attributes = $entry['attr'])) {
	    $ret .= make_attr($attributes);
	}
	$ret .= ">";
	if (is_array($content = $entry['subtree'])) {
	    $ret .= "\n";
	    foreach ($content as $key => $value) {
		$value = utf8_decode($value);
		$ret .= str_repeat($indent, $level + 2) . "<$key>$value</$key>\n";
	    }
	    $ret .= str_repeat($indent, $level + 1);
	} else {
	    $content = utf8_decode($entry['content']);
	    $ret .= "$content";
	}
	$ret .= "</$tag>\n";
    }
    $ret .= str_repeat($indent, $level) . "</info>\n";

    return $ret;
}


function lang_offset ($lang) {
    global $languages, $debug;

    if ($debug) {
	echo "Looking for langauge '$lang'<br>";
    }
    foreach ($languages as $offset => $lang_info) {
	if ($lang_info['abbr'] == $lang) {
	    if ($debug) {
		echo "Found offset for language '$lang': $offset<br>";
	    }
	    return $offset;
	}
    }
    exception("Unknown language '$lang'");
}


function escape_text ($text) {
    $text = preg_replace("/</", "&lt;", $text);
    $text = preg_replace("/>/", "&gt;", $text);
    return $text;
}



function call_handler ($annot, $args) {
    global $doc_root;

    if ($handler = $annot['appinfo']['subtree']['handler']) {
	$abs_handler = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$handler";
	if (is_file($abs_handler)) {
	    $php_code = join("", file($abs_handler));
	    if ($anon_func = create_function('$args', $php_code)) {
		if (!isset($args['sid'])) {
		    $args['sid'] = session_id();
		}
		$ret_xml = $anon_func($args);
		// So far, we through away the returned XML, maybe we want to do something with it in the future...
	    } else {
		die("<b>Fatal:</b> Unable to parse handler '$abs_handler':");
	    }
	} else {
	    die("<b>Fatal:</b> Can't find handler '$abs_handler'");
	}
    }
}

function make_handler_args ($args = array()) {
    global $doc_root, $cwd;
    $patterns = array("/\//", "/\./");	// Stuff we want to escape in doc root regexp should be added here
    $replacements = array("\/", "\.");	// ... and of course the escaping here...

    $doc_root_tmp = preg_replace("/^\/+/", "", $doc_root);
    $doc_root_tmp = preg_replace("/\/+$/", "", $doc_root_tmp);
    $doc_root_regexp = preg_replace($patterns, $replacements, $doc_root_tmp);
    $norm_cwd = normalize_path($cwd);
    $args['portal_abs_dir'] = preg_replace("/^\/*$doc_root_regexp/", "", $norm_cwd, 1);
    $args['portal_root'] = $doc_root_tmp;
    return $args;
}


function process_type ($name, $type, &$info, &$namespace, $level, &$path, $attr=array(), $node, $min, $max, $offset=-1) {
    global $write_file, $delete_node, $style_indent, $is_invalid, $valid, $typemap, $indent, $f, $languages, $debug, $doc_root, $admin_lang, $cwd;
    $ret = "";
    $hidden = "";
    $escape_field = 0;

    if ($formtype = $typemap[$type]) {			// Is this thing predeclared?
	if ($valid && ($valid_msg = element_valid ($node, $namespace, $level, $path, $type, $min, $max))) {
	    $is_invalid = 1;
	    $attr['valid'] = $valid_msg;
	    $escape_field = 1;
	}
	$this_path = get_form_name($path);
	$ret .= str_repeat($indent, $level) . "<field name=\"$name\" path=\"$this_path\" type=\"$formtype\"" . make_attr($attr). " indent=\"$style_indent\">\n";
	check_focus($path);
	if ($authoriZURL = $info['appinfo']['subtree']['authoriZURL']) {
	    if (preg_match("/.*\.tkl$/", $authoriZURL)) {
		if (!file_exists($zfn = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root$authoriZURL"))
		    die("Could not locate authority file $zfn");
		else {
		    if (!($auth_dom = domxml_open_file($zfn))) {
			die("<b>Fatal:</b> Unable to open/parse authority file '$zfn'");
		    }
		    $auth_root = $auth_dom->document_element();
		    if (is_array($enums = $auth_root->child_nodes())) {
			foreach ($enums as $enum) {
			    if ($enum->node_type() != XML_ELEMENT_NODE) {
				continue;
			    }
			    $enum_value = $enum->get_attribute('value');
			    if (is_array($enum_string_nodes = $enum->child_nodes())) {
				foreach ($enum_string_nodes as $enum_string_node) {
				    if ($enum_string_node->node_type() != XML_ELEMENT_NODE) {
					continue;
				    }
				    $enum_lang = $enum_string_node->get_attribute("lang");
				    if ($enum_lang != $admin_lang) {
					continue;
				    }
				    $enum_string = get_content($enum_string_node);
				    $ret .= str_repeat($indent, $level + 1) . "<enum value=\"$enum_value\">$enum_string</enum>\n";
				}
			    }
			}
		    }
		}
	    } else
		die("Fatal: Don't know how to deal with authoriZURL: $authoriZURL");
	} elseif ($file_select = $info['appinfo']['subtree']['file_select']) {
	    $abs_path = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$file_select";
	    if (is_dir($abs_path)) {
		if ($file_dir = @opendir($abs_path)) {
		    $enums = "";
		    while ($entry = readdir($file_dir)) {
			if ($entry == "." or $entry == ".." or $entry == "CVS") {
			    continue;
			}
			$enums .= str_repeat($indent, $level + 2) . "<enum value=\"$entry\"/>\n";
		    }
		    $ret .= str_repeat($indent, $level + 1) . "$enums\n";
		    closedir($file_dir);
		} else {
		    die("<b>Fatal:</b> Unable to open directory '$abs_path'");
		}
	    } else{
		die("<b>Fatal: No such directory '$abs_path'");
	    }
	}
	if (is_array($info)) {
	    $ret .= make_info($info, $level + 1);
	}
	if (!strlen($def_value = get_value($f, $path, $type))) {
	    $def_value = utf8_decode($node->get_attribute('default'));
	}

	//$def_value = escape_text($def_value); // Why is this one here??? Removed to make file-upload work!

	if ($escape_field) {
	    $def_value = "<![CDATA[" . $def_value . "]]>";
	}
        if ($field_handler = $info['appinfo']['subtree']['handler']) {
	    if (isset($delete_node) && ($delete_node == get_path_str($path))) {
		$upload_action = "delete";
	    } else {
		$upload_action = "upload";
	    }
	    if ($type != "xs:anyType") {	// We assume type is xs:anyType so we store the returned xml from handler
		die("<b>Fatal:</b> Element type must be <b>xs:anyType</b> when xs:appinfo/handler is specified");
	    }
	    $which_path = "f:" . join(":", $path) . ":value";
	    $upload_info = $_FILES[$which_path];
	    if ($upload_info['tmp_name'] =='none' || $def_value == 'unset') {
		set_node($path, array());
	    }
	    $abs_handler = $_SERVER['DOCUMENT_ROOT'] . "/$doc_root/$field_handler";
	    if (is_file($abs_handler)) {
		$php_code = join("", file($abs_handler));
		if ($anon_func = create_function('$args', $php_code)) {
		    $upload_content = get_node($f, $path);
		    $args = array('mimetype'	=>	$upload_info['type'],
		    		  'filename'	=>	$upload_info['name'],
				  'tmp'		=>	$upload_info['tmp_name'],
				  'size'	=>	$upload_info['size'],
		    		  'domain'	=>	$_SERVER['HTTP_HOST'],
				  'content'	=>	stripslashes($upload_content['value']),
				  'sid'		=>	session_id(),
		    		  'action'	=>	$upload_action);
		    if (strlen($write_file)) {
			if (!$file_spec) {
			    if (preg_match("/([^\/]*)$/", $write_file, $match)) {
				$args['tkl_doc'] = $match[1];
			    } else {
				die("<b>Fatal:</b> Unknown write file format: '$write_file'");
			    }
			}
		    }
		    $args = make_handler_args($args);
		    if ($upload_xml = $anon_func($args)) {
			$upload_xml = preg_replace("/<\?.*\?>/", "", $upload_xml);
			if (preg_match("/<error>(.*?)<\/error>/", $upload_xml, $match)) {
			    $is_invalid = 1;
			}
			$def_value = $upload_xml;
			set_node(array_merge($path, 'value'), $def_value);
		    }
		} else {
		    die("<b>Fatal:</b> Unable to parse handler '$abs_handler'");
		}
	    } else {
		die("<b>Fatal:</b>Call to undefinded field handle '$abs_handle'");
	    }
	}
	$ret .= str_repeat($indent, $level+ 1) . "<default>" . $def_value . "</default>\n";
	if ($info['appinfo']['subtree']['langdep'] && $offset != -1) {
	    $lang_path = array_merge($path, array("attr", "xml:lang"));
	    if ($lang_code = get_node($f, array_merge($lang_path, "value"))) {
		$lang_offset = lang_offset($lang_code);
		$lang_value = get_value($f, $lang_path);
	    } else {
		$lang_offset = $offset % count($languages);
		$lang_value = $languages[$lang_offset]['abbr'];
	    }
	    $ret .= str_repeat($indent, $level + 1) . "<language>" . $languages[$lang_offset]['desc'] . "</language>\n";
	    $hidden_fields .= str_repeat($indent, $level) . "<hidden path=\"" . get_form_name($lang_path) . "\" default=\"$lang_value\"/>\n";
	}
	$ret .= str_repeat($indent, $level) . "</field>\n";
	$ret .= $hidden_fields;
    } else {
	if ($ref_node = $namespace[$type]['complexType']) {  // Otherwise, it better be in the namespace...
	    if (is_choice($ref_node)) {
		if ($attr['more']) {
		    unset($attr['more']);
		}
	    }
	    $ret .= str_repeat($indent, $level) . "<struct name=\"$name\"" . make_attr($attr) . " indent=\"$style_indent\">\n";
	    $ret .= make_info($info, $level + 1);
	    $ret .= process($ref_node, $namespace, $level + 1, $path);
	    $ret .= str_repeat($indent, $level) . "</struct>\n";
	} elseif ($ref_node = $namespace[$type]['simpleType']) {
	    $ret .= process($ref_node, $namespace, $level, $path, array('name'=>$name, 'type'=>$type, 'info'=>$info, 'attr'=>$attr));
	} else {
	    exception("Unknown type '$type' for symbol name '$name'");
	}
    }
    return $ret;
}


function ref_node ($node) {	// Keeps following referenced nodes until the base node is found...
    while ($ref = $node->get_attribute('ref')) {	// is this a reference?
	$tag = $node->tagname;
	if ($ref_node = $namespace[$ref][$tag]) {
	    if ($ref_node == $node) {
		exception("self referenced declaration '$ref' in '$tag'");
	    }
	    $node = $ref_node;
	} else {
	    exception("reference to unknown symbol '$ref' in '$tag'");
	}
    }
    return $node;
}


function element ($node, &$namespace, $level=0, &$path, $context = 0) {
    global $move_up, $debug, $languages, $indent, $f, $append, $local_focus_name, $local_focus, $focus, $delete_node, $schema_ctx, $style_indent;
    $ret = "";
    $name = $node->get_attribute('name');	// Get as much info as possible from current node...
    $type = $node->get_attribute('type');
    $min = $node->get_attribute('minOccurs');
    $max = $node->get_attribute('maxOccurs');
    $org_node = $node;

    if (is_array($context)) {
	if (!strlen($min)) {
	    $min = $context['minOccurs'];
	}
	if (!strlen($max)) {
	    $max = $context['maxOccurs'];
	}
    }
    $node = ref_node($node);
    if (!$name) {					// Locally unset variables are set via the referenced object
	$name = $node->get_attribute('name');
    }
    if (!$type) {
	$type = $node->get_attribute('type');
    }
    if (!is_array($info = annotation($org_node))) {	// And likewise for annotations...
	$info = annotation($node);
    }
    if (!strlen($min)) {				// Default values for minOccurs and maxOccurs
	$min = 1;
    }
    if (!strlen($max)) {
	$max = "1";
    }
    if ($max == "unbounded") {				// Physical boundary
	$max = 9999999;
    }
    $max_offset = get_last($f, $path, $name);	// How many nodes do we already have?
    if ($info['appinfo']['subtree']['langdep']) {
	$lowest_offset = count($languages) - 1;
	if ($max_offset < $lowest_offset) {
	    $max_offset = $lowest_offset;
	}
    }
    if ($max_offset == -1) {
	$max_offset = 0;
    }
    if (isset($append) && $append == get_path_str(array_merge($path, $name))) {	// Are we going to append another element?
	$local_focus = $max_offset + 1;
	$local_focus_name = $name;
	if ($info['appinfo']['subtree']['langdep']) {
	    $max_offset = $max_offset + count($languages);
	} else {
	    $max_offset ++;
	}
    }
    $this_path_str = get_path_str(array_merge($path, $name));
    if (strlen($move_up)) {
	if (preg_match("/\[(\d+)\]$/", $move_up, $match)) {
	    $move_offset = $match[1];
	    $stripped = preg_replace("/\[$move_offset\]$/", "", $move_up);
	    if ($stripped == $this_path_str) {
		$new_offset = $move_offset - 1;
		$local_focus = $move_offset;
		$local_focus_name = $name;
		$new_path = $this_path_str . "[$new_offset]";
		//echo "Exchanging: '$move_up' with '$new_path'<br>";
		swap_elements($move_up, $new_path);
	    } else {
		unset($move_offset);
		unset($new_offset);
	    }
	} else {
	    echo "<b>Warning:</b> Unable to move element<br/>";
	}
    }

    if ($max_offset < ($min - 1)) {		// Always show at least minOccurs number of fields
	$max_offset = $min - 1;
    }
    if ($max_offset >= $max) {
	$max_offset = $max - 1;
    }

    $info_xml = make_info($info, $level + 1);
    if ($sub_node = dom_select($node, array("complexType", "simpleContent", "extension"))) {
	return $ret . extension($sub_node, $namespace, $level, $path, $info);
    }
    for ($offset = 0; $offset <= $max_offset; $offset ++) {	// Loop through node-set
	$ext_path = array_merge($path, array($name, $offset));
	if (($offset == $max_offset) && ($max_offset < ($max - 1))) {	// There are room for more elements, inform XSLT...
	    $more = array('more'=>get_path_str(array_merge($path, $name)));
	} else {
	    $more = array();
	}
	if ($offset > 0) {
	    $more['moveUp'] = get_path_str($ext_path);
	}
	if ($max_offset > $min) {	// If we have more nodes than required, insert a delete button in XSLT...
	    $more['delete'] = get_path_str($ext_path);
	}
	//if (isset($delete_node) && ($delete_node == get_path_str($ext_path))) {
	//    continue;
	//}
	if ($type) {						// Do we have a type?
	    $processed = process_type($name, $type, $info, $namespace, $level, $ext_path, $more, $node, $min, $max, $offset);
	} else {						// Otherwise, the structure is a subtree...
	    if (list($sub_node) = get_elements_by_tagname($node,"simpleType")) { // SimpleType and ComplexTypes are handled differently...
		$processed = process($sub_node, $namespace, $level, $ext_path, array('name'=>$name, 'type'=>$type, 'info'=>$info_xml, 'attr'=>$more));
	    } else {
		if (is_array($complex_subtree = dom_select_ext($node, array("complexType")))) {
		    $complex_node = array_shift($complex_subtree);
		} else {
		    die("<b>Fatal:</b> Schema error: Element '$name' must have either type attribute or a simpleType or complexType substructure");
		}
		if (is_choice($complex_node)) {
		    if ($more['more']) {
			unset($more['more']);
		    }
		}
		$processed = str_repeat($indent, $level) . "<struct name=\"$name\"" . make_attr($more) . " indent=\"$style_indent\">\n" .
	            $info_xml .
	            process_subtree($node, $namespace, $level + 1, $ext_path) .
		    str_repeat($indent, $level) . "</struct>\n";
	    }
	}
	if (isset($delete_node) && ($delete_node == get_path_str($ext_path))) {
	    continue;
	}
	$ret .= $processed;
    }
    return $ret;
}


function is_choice ($node) {
    $children = dom_select_ext($node, array('choice'));
    if (is_array($children)) {
	return count($children);
    } else {
	return 0;
    }
}



function complextype ($node, &$namespace, $level, &$path) {
    global $style_indent, $max_indent;

    $style_indent ++;
    if ($style_indent > $max_indent) {
	$max_indent = $style_indent;
    }
    $ext_path = array_merge($path, array("subtree"));
    $subtree_xml = process_subtree($node, $namespace, $level, $ext_path);
    $style_indent --;
    return $subtree_xml;
}


function simplecontent ($node, &$namespace, $level, &$path) {
    $reduced_path = reduce_path($path);
    return process_subtree($node, $namespace, $level, $reduced_path);
}


function choice ($node, &$namespace, $level, &$path) {
    global $indent, $choice_path, $f, $local_focus, $local_focus_name;
    $min = $node->get_attribute("minOccurs");
    $max = $node->get_attribute("maxOccurs");
    $reduced_path = reduce_path($path);
    $offset = array_pop($reduced_path);
    $base_path = $reduced_path;
    $name = array_pop($reduced_path);
    $max_offset = get_last($f, $reduced_path, $name);
    if (is_array($kids = $node->child_nodes())) {			// Which children does the choice construction have?
	foreach ($kids as $kid) {
	    if (strlen($elem = $kid->tagname)) {
		if ($elem = "element") {				// Store true elements
		    $sub_elements[$kid->get_attribute('name')] = $kid;
		} else {
		    exception("Only xs:element tags are allowed as children of xs:choice");
		}
	    }
	}
	if (!is_array($sub_elements)) {					// We only support elements in a choice construction!
	    exception("Found no xs:element subtags under xs:choice");
	}
	foreach ($sub_elements as $sub_name => $element) {
	    if (get_last($f, $path, $sub_name) != -1) {			// Any elements of this type?
		$ret .= process($element, $namespace, $level, $path);	// If yes, then process them...
		if ($offset == $max_offset || $max_offset == -1) {
		    $ret .= str_repeat($indent, $level - 1) . "</struct>\n";
		    $ret .= str_repeat($indent, $level - 1) . "<struct name=\"$name\">\n";
		}
		break;
	    }
	}
	if ($offset == $max_offset || $max_offset == -1) {					// If we're looking @ last element, inform XSLT
	    if ($max_offset == -1) {
		$append_offset = 0;
	    } else {
		$append_offset = $offset + 1;
	    }
	    $append_choice_path = array_merge($reduced_path, $name, $append_offset, "subtree");
	    if (isset($choice_path)) {
		$choice_path_mod = preg_replace("/^\[/", "", $choice_path);
		$choice_path_mod = preg_replace("/\]$/", "", $choice_path_mod);
		$choice_path_array = preg_split("/\]\[/", $choice_path_mod);
		$choice_field = array_pop($choice_path_array);
		if ($choice_path == get_path_str(array_merge($append_choice_path, $choice_field))) {
		    $local_focus = $append_offset;
		    $local_focus_name = $name;
		    $ret .= process($sub_elements[$choice_field], $namespace, $level, $append_choice_path);
		    $max_offset ++;
		}
	    }
	    $ret .= str_repeat($indent, $level) . "<choice>\n";		// to insert a more button...
	    foreach ($sub_elements as $element) {
		if (!is_array($info = annotation($element))) {
		    $element = ref_node($element);
		    $info = annotation($element);
		}
		$sub_name = $element->get_attribute('name');
		$ret .= str_repeat($indent, $level + 1) . "<select path=\"" .
		        get_path_str(array_merge($base_path, $max_offset + 1, "subtree", $sub_name)) . "\">\n" .
		        make_info($info, $level + 2) .
		        str_repeat($indent, $level + 1) . "</select>\n";
	    }
	    $ret .= str_repeat($indent, $level) . "</choice>\n";
	}
	return $ret;
    } else {
	exception("xs:choice must have xs:element children");
    }
}


function reduce_path (&$path) {		// Consume path back to last subtree occurrence
    $reduced_path = array();
    $append = 0;
    for ($i = count($path) - 1; $i >= 0; $i--) {
	if (!$append && ($path[$i] == "subtree")) {
	    $append = 1;
	    continue;
	}
	if ($append) {
	    array_unshift($reduced_path, $path[$i]);
	}
    }

    return $reduced_path;
}


function extension ($node, &$namespace, $level, &$path, $info=0) {	// This code is tuned for the insertion of the lang attribute. It is not tested and intended for other purposes!
    global $f, $append, $called, $delete_node;
    $ret = "";

    if ($type = $node->get_attribute('base')) {
	$tag = "";
	$parent = $node;
	while ($tag != "element") {			// Navigate up in the hierarchy to find the named element
	    $parent = $parent->parent_node();
	    $tag = $parent->tagname;
	}
	if (!($name = $parent->get_attribute('name'))) {
	    exception("Extension tag must be embedded in a named element");
	}
	$max = $parent->get_attribute('maxOccurs');
	$min = $parent->get_attribute('minOccurs');
	if (!$info) {
	    if (!is_array($info = annotation($parent))) {     // And likewise for annotations...
		$info = annotation($node);
	    }
	}
	if (!strlen($min)) {                                // Default values for minOccurs and maxOccurs
	    $min = 1;
	}
	if (!strlen($max)) {
	    $max = "1";
	}
	if ($max == "unbounded") {                          // Physical boundary
	    $max = 9999999;
	}
	$max_offset = get_last($f, $path, $name);   // How many nodes do we already have?
	if ($max_offset == -1) {
	    $max_offset = 0;
	}
	if (isset($append) && $append == get_path_str(array_merge($path, $name))) { // Are we going to append another field?
	    $max_offset ++;
	}
	if ($max_offset < ($min - 1)) {             // Always show at least minOccurs number of fields
	    $max_offset = $min - 1;
	}
	if ($max_offset >= $max) {
	    $max_offset = $max - 1;
	}
	$info_xml = make_info($info, $level + 1);
	for ($offset = 0; $offset <= $max_offset; $offset ++) {     // Loop through node-set
	    $ext_path = array_merge($path, array($name, $offset));
	    if (($offset == $max_offset) && ($max_offset < ($max - 1))) {   // There are room for more elements, inform XSLT...
		$more = array('more'=>get_path_str(array_merge($path, $name)));
	    } else {
		$more = array();
	    }
	    if ($max_offset > $min) {	// If we have more nodes than required, insert a delete button in XSLT...
		$more['delete'] = get_path_str($ext_path);
	    }
	    if (isset($delete_node) && ($delete_node == get_path_str($ext_path))) {
		continue;
	    }
	    $ret .= process_type($name, $type, $info, $namespace, $level, $ext_path, $more, $node, $min, $max, $offset);
	    $ret .= process_subtree($node, $namespace, $level, $ext_path);
	}
	return $ret;
    } else {
	exception("There is no base attribute in extension tag");
    }
}


function check_focus ($path) {
    global $local_focus, $focus, $local_focus_name;
    $my_path = $path;

    if (strlen($local_focus)) {
	do {
	    list($field, $offset, $type) = array(array_shift($my_path), array_shift($my_path), array_shift($my_path));
	    //echo "FIELD='$field', OFFSET='$offset', FOCUS_NAME='$local_focus_name', FOCUS_OFF='$local_focus'<br>";
	    if (strlen($field) && strlen($offset) && $local_focus_name == $field && $local_focus == $offset) {
		$focus = get_form_name($path);
		$local_focus = 0;
		break;
	    }
	} while ($field);
    }
}


function simpletype ($node, &$namespace, $level, &$path, &$context) {
    global $f, $indent, $typemap, $style_indent;
    $name = $context['name'];
    $attr = $context['attr'];
    $info = $context['info'];

    if (list($sub_node) = get_elements_by_tagname($node,'restriction')) {
	$sub_info = restriction($sub_node, $namespace, $level, $path, $context);
    } else {
	exception("simpleType without any restriction sub tag");
    }
    $type = $typemap[$sub_info['base']];
    $enum = $sub_info['enum'];

    $this_path = get_form_name($path);
    $ret .= str_repeat($indent, $level) . "<field name=\"$name\" path=\"$this_path\" type=\"$type\"" . make_attr($attr). " indent=\"$style_indent\">\n";
    check_focus($path);
    $ret .= $info . $enum . str_repeat($indent, $level);
    $ret .= str_repeat($indent, $level + 1) . "<default>" . escape_text(get_value($f, $path)) . "</default>\n";
    $ret .= str_repeat($indent, $level) . "</field>\n";
    return $ret;
}


function sequence ($node, &$namespace, $level, &$path) {
    return process_subtree($node, $namespace, $level, $path);
}


function maxlength ($node, &$namespace, $level, &$path) {
    return process_subtree($node, $namespace, $level, $path);
}


function pattern ($node, &$namespace, $level, &$path) {
    return process_subtree($node, $namespace, $level, $path);
}


function attribute ($node, &$namespace, $level, $path) { // So far, we treat attributes as elements...
    $tag = 'attribute';
    if ($ref = $node->get_attribute('ref')) {		// Is this a reference?
	if ($ref_node = $namespace[$ref][$tag]) {
	    if ($ref_node == $node) {
		exception("Self referenced declaration '$ref' in '$tag'");
	    }
	    return process($ref_node, $namespace, $level, $path);
	} else {
	    exception("Reference to unknown symbol '$ref' in '$tag'");
	}
    }
    $info = annotation($node);
    $name = $node->get_attribute('name');
    $type = $node->get_attribute('type');
    if ((string) $path[count($path) - 1] == 'subtree') {
	array_pop($path);
    }
    $ext_path = array_merge($path, array("attr", $name));
    if ($type) {                                    // Do we have a type?
	return process_type($name, $type, $info, $namespace, $level, $ext_path, array(), $node, $min, $max);	// Remember to implement $info here!!!!
    } else {
	exception("Attribute '$name' with no type");
    }
}


function restriction ($node, &$namespace, $level, &$path, $context=0) {
    $ret = array();
    if ($base = $node->get_attribute('base')) {
	$ret['base'] = $base;
    } else {
	exception("No base attribute present");
    }
    $ret['enum'] = process_subtree($node, $namespace, $level + 1, $path, $context);
    return $ret;
}


function enumeration ($node, &$namespace, $level, &$path, $context=0) {
    global $indent;

    if ($value = $node->get_attribute('value')) {
	return str_repeat($indent, $level) . "<enum value=\"$value\"/>\n";
    } else {
	exception("Enumeration tag without value attribute");
    }
}


function process ($node, &$namespace, $level=0, &$path, $context=0) {
    global $valid;

    if ($tag = $node->tagname) {
	if ($tag == "annotation" || $tag == "extension") {	// Annotations/extensions are handled elsewhere, neglect them here...
	    return;
	}
	if (function_exists($tag)) {
	    if (is_array($context)) {
		$result = $tag($node, $namespace, $level, $path, $context);
	    } else {
		$result = $tag($node, $namespace, $level, $path);
	    }
	    return $result;
	} else {
	    exception("Unsupported tag: '$tag'");
	}
    }
}

function annotation ($node, $found=0) {
    // Extracts the content of an annotation tag, and returns a nested associative array.
    // If there is no annotation sub-node, false is returned.

    if (is_array($entries = $node->child_nodes())) {
	foreach ($entries as $entry) {
	    if ($tag = $entry->tagname) {
		if ($tag != "annotation") {
		    if (!$found) {
			continue;
		    } else {
			if (is_array($sub_entries = $entry->child_nodes())) {
			    foreach ($sub_entries as $sub_entry) {
				if (($content = trim(get_content($sub_entry))) && $sub_entry->tagname) {
				    $info[$tag]['subtree'][$sub_entry->tagname] = $content;
				} elseif (trim($content)) {
				    $info[$tag]['content'] = $content; }
			    }
			}
		    }
		} else {
		    return annotation($entry, 1);
		}
	    }
	}
	return $info;
    } else {
	return 0;
    }
}


function process_subtree ($node, &$namespace, $level, &$path, $context=0) {
    $ret = "";
    if ($kids = $node->child_nodes()) {
	foreach ($kids as $kid) {
	    $ret .= process($kid, $namespace, $level, $path, $context);
	}
    }
    return $ret;
}


function schema ($node, &$namespace, $level=0, &$path) {
    return process_subtree($node, $namespace, $level, $path);
}


$path = array();
create_namespace($schema_root, $namespace = array());

if (strlen($start)) {
    $output_xml = process($namespace[$start]['element'], $namespace, 1, $path);
} else {
    $output_xml = process($schema_element_root, $namespace, 1, $path);
}

$write_error = 0;
if ($save && is_array($f) && (!$is_invalid || $url)) {
    $xml_data = $xml_header. create_xml($f);
    if ($debug) {
	echo "<hr/>Writing:<pre>", htmlentities($xml_data), "</pre><hr/>";
    }
    if (isset($write_file)) {
	$filename = $write_file;
	if ($file_spec && strlen($write)) {
	    $filename = "$filename/$write";
	}
	if (!is_granted($filename, "write")) {
	    echo "<h1>Write access error</h1>\n";
	    die;
	    $write_error = 2;
	} elseif ($file_spec && file_exists($filename)) {
	    $write_error = 1;
	} else {
	    if (!($fh = fopen($filename, "w"))) {
		exception("Unable to open file '$filename' for writing");
	    }
	    if (!(fputs($fh, $xml_data))) {
		exception("Unable to write xml data to file '$filename'");
	    }
	    fclose($fh);
	    if ($debug) {
		echo "Wrote xml data to file '$filename'<br>";
	    }
	    $saved = 1;
	    search_index($filename);
	    if (is_array($schema_annotation)) {
		$hndl_args = array('action' => 'commit');
		if (preg_match("/([^\/]*)$/", $filename, $match)) {
		    $hndl_args['tkl_doc'] = $match[1];
		}
		$hndl_args = make_handler_args($hndl_args);
		call_handler($schema_annotation, $hndl_args);
	    }
	}
    }
} elseif ($close_win) {
    if (is_array($schema_annotation)) {
	$hndl_args = array('action' => 'cleanup');
	if (!$file_spec) {
	    if (preg_match("/([^\/]*)$/", $write_file, $match)) {
		$hndl_args['tkl_doc'] = $match[1];
	    } else {
		die("<b>Fatal:</b> Unknown write file format: '$write_file'");
	    }
	}
	$hndl_args = make_handler_args($hndl_args);
	call_handler($schema_annotation, $hndl_args);
    }
}
$creator_info = get_user_info($creator);
$creator_name = $creator_info['name'];
$output_xml = $xml_header . "<xform focus=\"$focus\" invalid=\"$is_invalid\" saved=\"$saved\" url=\"$url\" creator_name=\"$creator_name\" creator=\"$creator\" allow_write=\"$allow_write\" cwd=\"$cwd\" write=\"$write\" write_file=\"$write_file\" schema=\"$schema\" action=\"$xml_editor\" root=\"$start\" error=\"$write_error\" file_spec=\"$file_spec\" max_indent=\"$max_indent\">\n" . $output_xml;
$output_xml .= "</xform>\n";
if ($debug) {
    echo "<pre>\n", htmlentities($output_xml), "\n</pre>\n";
}
$xslt = xslt_create();
if ($result = xslt_process($xslt, "arg:/_xml", "xform2.xsl", NULL, array('/_xml' => $output_xml), array('doc_root'=>$_SERVER['DOCUMENT_ROOT'] . "/$doc_root", 'admin_lang' => $admin_lang, 'domain' => $_SERVER['SERVER_NAME'], 'close_win' => $close_win))) {
    echo $result;
} else {
    echo sprintf("Kunne ikke hndtere XML dokument [%d]: %s", xslt_errno($xslt), xslt_error($xslt));
    die;
}
xslt_free($xslt);


// $Log: xform2.php,v $
// Revision 1.17  2003/06/24 08:47:26  sondberg
// New version of authority file format and corrected a bug in the way we
// remove the doc_root prefix in make_handler_args.
//
// Revision 1.16  2003/06/10 12:38:11  adam
// Dollar id in headers
//
// Revision 1.15  2003/05/21 13:52:31  sondberg
// Tightened the syntax requirement for local type definitions. Fixes the problem
// with a silly extra add button in the insert choice field.
//
// Revision 1.14  2003/05/15 14:50:25  sondberg
// Now xs:choice works when it is addressed in more than one field.
//
// Revision 1.13  2003/05/15 08:54:13  sondberg
// Various handler stuff: A clean-up handler can be associated with a schema.
//
// Revision 1.12  2003/05/14 13:19:47  perhans
// Added functionality to read a local config file
//
// Revision 1.11  2003/05/08 13:37:44  sondberg
// Added file_upload feature.
// Allowing annotation elements to schema document element, where one can
// associate a handle, which will be called at save/about time.
//
// Revision 1.10  2003/04/03 08:53:09  sondberg
// Implemented extract_cwd.
//
// Revision 1.9  2003/03/31 08:25:19  sondberg
// Corrected a bug: Now xform sets focus on first added entry.
//
// Revision 1.8  2003/03/10 19:30:47  sondberg
// Removed the entity escaping hack again - it was too ugly afterall!
//
// Revision 1.7  2003/03/07 14:37:50  sondberg
// Applied functions to fix problem with entities.
//
// Revision 1.6  2003/03/05 14:39:53  sondberg
// Added feature to move elements.
//
// Revision 1.5  2003/03/04 19:12:53  sondberg
// Focus now works for choice fields.
//
// Revision 1.4  2003/03/04 12:46:03  sondberg
// Now browser focus works for ordinary fields and subtree. TODO: choice.
//
// Revision 1.3  2003/03/04 08:48:52  sondberg
// Introduced the focus idea - works for fields. TODO: Should work for structs as well.
//
// Revision 1.2  2003/03/03 17:32:32  sondberg
// file drop_down. And preprared for auto-focus.
//
// Revision 1.1  2003/03/03 14:20:47  sondberg
// The xform2 is now the default one.
//
// Revision 1.75  2003/02/04 13:23:06  sondberg
// Now we're supporting default files.
//
// Revision 1.74  2003/02/03 23:12:26  sondberg
// Added a few parameters to xslt, i.e. doc_root and admin_lang.
//
// Revision 1.73  2003/02/03 12:47:16  sondberg
// Escaping < and >.
//
// Revision 1.72  2003/02/03 09:14:12  sondberg
// Removed insert button for choice subtrees.
//
// Revision 1.71  2003/01/27 14:39:44  sondberg
// Added support for xs:choice in the schema.
//
// Revision 1.70  2003/01/13 14:25:28  sondberg
// Finally, the double slash found its way to cvs.
//
// Revision 1.69  2003/01/13 14:14:45  sondberg
// escape_amp is called for each attribute value.
//
// Revision 1.68  2003/01/13 09:23:53  sondberg
// Applied utf8_decode upon the default element attribute.
//
// Revision 1.67  2003/01/10 13:48:22  sondberg
// The function process is called with root xs:element node (to avoid ambiguity
// with respect to document element for schemas with named types).
//
// Revision 1.66  2003/01/06 13:36:13  sondberg
// xform maintains document element attributes: modifier, modified.
//
// Revision 1.65  2002/11/20 10:31:27  sondberg
// Cleaning up.
//
// Revision 1.64  2002/11/20 10:18:29  sondberg
// Added a indent attribute to struct and field elements.
//
// Revision 1.63  2002/10/16 09:23:48  sondberg
// Now the delete field buttons apply to extension fields as well
//
// Revision 1.62  2002/10/09 13:27:06  sondberg
// Replaced dump_node with my home brewed php version: dump_xml.
//
// Revision 1.61  2002/10/04 10:06:41  quinn
// Work
//
// Revision 1.60  2002/10/03 10:07:36  sondberg
// Created date format is now human readable, i.e. YYYY-MM-DD, HH:MM:SS
//
// Revision 1.59  2002/10/03 09:32:26  sondberg
// Ooops, created instead of modified.
//
// Revision 1.58  2002/10/03 08:15:58  sondberg
// Xform keeps track of a modified epoch time.
//
// Revision 1.57  2002/09/25 12:27:54  sondberg
// Implemented the default facility.
//
// Revision 1.56  2002/09/25 12:27:10  sondberg
// *** empty log message ***
//
// Revision 1.55  2002/09/13 08:53:12  adam
// Compatible DOMXML (PHP 4.1, 4.2 and 4.3 shold work)
//
// Revision 1.54  2002/09/12 14:12:10  sondberg
// Now it checks for well-formed ness, before saving.
//

?>

